'****************************************************************************************
'* muicache! toolkit v1.0
'* RegToXml.vbs - client-side WSH script
'* Authors: Mirko Iodice (mirko at notageek.it), Luca Alberti
'* More info: http://www.notageek.it/muicache-toolkit.html
'****************************************************************************************

Option Explicit

'---------------------Global Declarations---------------------------------------------------
Dim strComputer, User, Pc, DestPath, XmlName, strKeyPathXp, strKeyPathVista, LongName, Present, i, svalue, KeyPresent, RegistryKeyExists
Dim strvalue, strKeyPath, TmpDest, Cleanstrvalue, strpath, strcommand, ScheduleEvery, Execution, aSubkeys, s
Dim ObjShell, ObjFSO, ObjNet, ObjXmlDoc, ObjRoot, ObjReg, ObjRecord, ObjIntro, objWMI, ObjOs, WshShell
Dim arrValueNames, arrValueTypes, ColOS
Const HKCU = &H80000001
'DestPath = Left(WScript.ScriptFullName, InstrRev(WScript.ScriptFullName, "\")) ' leave this line for debugging purposes
RegistryKeyExists = False
strComputer ="."
'------------------------------------------------------------------------------------------
ScheduleEvery = 1
DestPath = "\\server\muicache\"
'------------------------Script engine check-----------------------------------------------
If LCase(Right(WScript.FullName, 11)) <> "cscript.exe" Then
	Set WshShell = CreateObject("WScript.Shell")
    strPath = WScript.ScriptFullName
    strCommand = "%comspec% /c cscript " & Chr(34) & strPath & chr(34)
	WshShell.Run strcommand, 0

	Set WshShell = Nothing

   WScript.Quit

End If
'------------------------------------------------------------------------------------------

'-------------------------Execution Check--------------------------------------------------

Set ObjReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & _
   strComputer & "\root\default:StdRegProv")

   ObjReg.EnumKey HKCU, "SOFTWARE", aSubkeys
   If Not IsNull(aSubkeys) Then
       For Each s In aSubkeys
           If lcase(s)=lcase("muicache") Then
               RegistryKeyExists = True
           End If
       Next
   End If
	
	
	If RegistryKeyExists = True Then 
	
		If ScheduleEvery <> 0 Then 
		
			ObjReg.GetStringValue HKCU,"SOFTWARE\muicache", "LastExecution", svalue
	
				If ScheduleEvery - 1 > DateDiff("d", svalue, Date)  Then
			
			 	WScript.quit

				End If
		End If
	End if

'------------------------------------------------------------------------------------------


'---------------------Reference Object and other stuff..-----------------------------------

strKeyPathXp = "SOFTWARE\Microsoft\Windows\ShellNoRoam\MUICache"
strKeyPathVista = "SOFTWARE\Classes\Local Settings\Software\Microsoft\Windows\Shell\MUICache"

Set ObjShell = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")

User=ObjShell.ExpandEnvironmentStrings("%USERNAME%")
TmpDest=ObjShell.ExpandEnvironmentStrings("%TMP%")

Set objNet = CreateObject("WScript.Network")
Pc = objNet.ComputerName
XmlName = Pc & "@" & User & ".xml"

set objWMI = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
set colOS = objWMI.InstancesOf("Win32_OperatingSystem")
for each objOS in colOS
    if  Left(objOS.Version, 1) = 6 then
        strkeypath = strkeypathVista
    else
        strkeypath = strkeypathXp
    end if
   
next

Set ObjxmlDoc = CreateObject("Microsoft.XMLDOM")

Set ObjRoot = ObjxmlDoc.createElement("muiset")
 ObjxmlDoc.appendChild objRoot
 objroot.setAttribute "Pc",PC
 objroot.setAttribute "User",User
 objroot.setAttribute "ExecutionDate",Date
 
 ObjReg.EnumValues HKCU, strKeyPath,_
   arrValueNames, arrValueTypes
 
'----------------------------------------------------------------------------------------


'----------------------Main Script-------------------------------------------------------

For i=0 To UBound(arrValueNames)
 if Left(arrValueNames(i), 1) <> "@" then
  If arrValueNames(i) <> "LangID" then
   if ObjFSO.FileExists(arrValueNames(i)) Then

    Set objRecord = ObjxmlDoc.createElement("Record")
    objRoot.appendChild objRecord
    present = true      
    Longname = ShortToLong(arrValueNames(i))
    objrecord.setAttribute "Path", Longname
   Else
   Set objRecord = ObjxmlDoc.createElement("Record")
    objRoot.appendChild objRecord
    objrecord.setAttribute "Path", arrValueNames(i)
   end if

          ObjReg.GetStringValue HKCU,strKeyPath, arrValueNames(i),strvalue
           Cleanstrvalue = Replace(strvalue,Chr(34),"")
           objrecord.setAttribute "Description", Cleanstrvalue
 
   if present = true then
           objrecord.setAttribute "Version", objFSO.GetFileVersion(Longname)         
    objrecord.setAttribute "Hash", HashMyfile(Longname)
   else
    objrecord.setAttribute "Hash", "Not Found"       
           objrecord.setAttribute "Version", ""
   End if
   present = false
  End if
 End if

Next

Set objIntro = ObjxmlDoc.createProcessingInstruction("xml","version='1.0'")
ObjxmlDoc.insertBefore objIntro,ObjxmlDoc.childNodes(0)
ObjxmlDoc.Save TmpDest & "\" & XmlName

If ObjFSO.FolderExists(DestPath) Then 
	
	ObjFSO.CopyFile TmpDest & "\" & XmlName, DestPath
	ObjFSO.DeleteFile(TmpDest & "\" & XmlName)
	
End If

If RegistryKeyExists = True Then
	ObjReg.SetStringValue HKCU, "SOFTWARE\muicache", "LastExecution", CStr(Date)
Else 
	ObjReg.CreateKey HKCU, "SOFTWARE\muicache"
	ObjReg.SetStringValue HKCU, "SOFTWARE\muicache", "LastExecution", CStr(Date)
End If

'wscript.echo "fine scrittura xml"

Set ObjReg = Nothing
wscript.quit

'---------------------------------------------------------------------------


'---------------------Functions & Subs --------------------------------------------

Function HashMyfile(path)

Dim FSO, ObjFile, ObjShell, ObjExec, objRegEx, colMatches, match
Dim Size, StrCommand, strOut, hash, chrpattern, chrpattern2
Set objRegEx = CreateObject("VBScript.RegExp")
objRegEx.Global = True
Set FSO = CreateObject("Scripting.FileSystemObject")
Set objFile = FSO.GetFile(path)
Size = objFile.Size
chrpattern = "Error\s(msg)\W+\s.*"
chrpattern2 = "\w{32}"
strcommand = "fciv " & chr(34) & path & chr(34)
Set ObjShell = CreateObject("Wscript.Shell")


Set ObjExec = ObjShell.Exec(strcommand)

strOut=trim(ObjExec.StdOut.ReadAll)
objRegEx.Pattern = chrpattern
	 Set colMatches = objRegEx.Execute(strout)
    		If colMatches.Count > 0 Then
    			For Each match In colmatches
    				HashMyfile = Replace(match.value,"Error msg  : ","")
    			next
    		Else 
    				objRegEx.Pattern = chrpattern2
    				Set colMatches = objRegEx.Execute(strout)
    				If colMatches.Count > 0 Then
    					For Each match In colmatches
    						HashMyfile = match.value & ":" & size & ":32771"
    					Next
    					
    				Else 
    					HashMyfile = "Not Recognized"
    						
    				End If	
	
			End if

Set objfile = nothing
Set FSO = nothing

end function

'-------------------------------------------------------------------------
Function ShortToLong(ShortName)
 
dim oFS, oFI

Set oFS = CreateObject("Scripting.FileSystemObject")
Set oFi = oFS.GetFile(ShortName)
 
With CreateObject("Wscript.Shell")
 
    With .CreateShortcut("dummy.lnk")
    
        .TargetPath = oFi
        ShortToLong = .TargetPath
        
    End with
 
End with


set oFS = Nothing
set oFi = nothing
 
End Function

'--------------------------------------END OF FILE----------------------------------------------------------------------------------- 